> ## Documentation Index
> Fetch the complete documentation index at: https://developer.dromo.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Update an import schema



## OpenAPI

````yaml /api-reference/openapi.json put /schemas/{id}/
openapi: 3.1.0
info:
  title: Dromo
  description: >-
    Dromo's APIs provide convenient programmatic access to your uploads and
    schemas. You can use them to create powerful automated workflows.
  termsOfService: https://dromo.io/legal/terms
  contact:
    name: Dromo
    email: contact@dromo.io
  version: '1.0'
servers:
  - url: https://app.dromo.io/api/v1
security:
  - api_key: []
tags:
  - name: uploads
    description: Viewing completed imports
  - name: import-schemas
    description: Creating and viewing import schemas
  - name: headless
    description: Creating and viewing headless imports
  - name: sftp-credentials
    description: Managing SFTP server credentials
  - name: sftp-connectors
    description: Managing SFTP automated import connectors
paths:
  /schemas/{id}/:
    put:
      tags:
        - import-schemas
      summary: Update an import schema
      operationId: updateImportSchema
      parameters:
        - name: id
          in: path
          description: Headless import ID
          required: true
          schema:
            type: string
            format: uuid
            example: 66d6300d-1414-4655-83b4-8c80fc527315
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ImportSchema'
      responses:
        '200':
          description: The updated schema
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ImportSchema'
        '404':
          description: Not found
components:
  schemas:
    ImportSchema:
      type: object
      example:
        id: 0631f213-ca91-41e0-9a88-7430c7d0ca28
        name: last - email
        fields:
          - key: lastName
            type: string
            label: last
            validators:
              - validate: required
          - key: email
            type: email
            label: email
            validators:
              - validate: required
        settings:
          type: object
          properties:
            importIdentifier:
              type: string
            title:
              type: string
            allowInvalidSubmit:
              type: boolean
            invalidDataBehavior:
              type: string
              enum:
                - BLOCK_SUBMIT
                - INCLUDE_INVALID_ROWS
                - REMOVE_INVALID_ROWS
                - INCLUDE_INVALID_ROWS_AND_VALUES
            backendSync:
              type: boolean
            backendSyncMode:
              type: string
              enum:
                - DISABLED
                - FULL_DATA
                - MAPPINGS_ONLY
            manualInputDisabled:
              type: boolean
            manualInputOnly:
              type: boolean
            allowCustomFields:
              type: boolean
            passThroughUnmappedColumns:
              type: boolean
            maxRecords:
              oneOf:
                - type: integer
                - type: 'null'
            developmentMode:
              type: boolean
            displayEncoding:
              type: boolean
            styleOverrides:
              type: object
            maxFileSize:
              type: integer
            webhookUrl:
              oneOf:
                - type: string
                - type: 'null'
            needsReviewWebhookUrl:
              oneOf:
                - type: string
                - type: 'null'
            initialData:
              oneOf:
                - type: array
                - type: 'null'
          additionalProperties: false
        hooks:
          type: object
          properties:
            rowHooks:
              type: array
              items:
                type: string
            bulkRowHooks:
              type: array
              items:
                type: string
            rowDeleteHooks:
              type: array
              items:
                type: string
            beforeFinishCallback:
              type: string
            columnHooks:
              type: array
              items:
                type: object
                properties:
                  fieldName:
                    type: string
                  callback:
                    type: string
                required:
                  - fieldName
                  - callback
                additionalProperties: false
            stepHooks:
              type: array
              items:
                type: object
                properties:
                  type:
                    type: string
                    enum:
                      - UPLOAD_STEP
                      - REVIEW_STEP
                      - REVIEW_STEP_POST_HOOKS
                  callback:
                    type: string
                required:
                  - type
                  - callback
                additionalProperties: false
          additionalProperties: false
      properties:
        id:
          type: string
          readOnly: true
        name:
          type: string
        fields:
          type: array
          items:
            type: object
            properties:
              key:
                type: string
              type:
                oneOf:
                  - type: string
                  - type: array
              label:
                type: string
              description:
                type: string
              alternateMatches:
                type: array
                items:
                  type: string
              validators:
                type: array
                items:
                  type: object
              invalidValueMessage:
                type: string
              readOnly:
                type: boolean
              hidden:
                type: boolean
              requireMapping:
                type: boolean
              manyToOne:
                type: boolean
            required:
              - key
              - type
              - label
            additionalProperties: false
        settings:
          type: object
          properties:
            importIdentifier:
              type: string
            title:
              type: string
            allowInvalidSubmit:
              type: boolean
            invalidDataBehavior:
              type: string
              enum:
                - BLOCK_SUBMIT
                - INCLUDE_INVALID_ROWS
                - REMOVE_INVALID_ROWS
                - INCLUDE_INVALID_ROWS_AND_VALUES
            backendSync:
              type: boolean
            backendSyncMode:
              type: string
              enum:
                - DISABLED
                - FULL_DATA
                - MAPPINGS_ONLY
            manualInputDisabled:
              type: boolean
            manualInputOnly:
              type: boolean
            allowCustomFields:
              type: boolean
            passThroughUnmappedColumns:
              type: boolean
            maxRecords:
              oneOf:
                - type: integer
                - type: 'null'
            developmentMode:
              type: boolean
            displayEncoding:
              type: boolean
            styleOverrides:
              type: object
            maxFileSize:
              type: integer
            webhookUrl:
              oneOf:
                - type: string
                - type: 'null'
            needsReviewWebhookUrl:
              oneOf:
                - type: string
                - type: 'null'
            initialData:
              oneOf:
                - type: array
                - type: 'null'
          additionalProperties: false
        hooks:
          type: object
          properties:
            rowHooks:
              type: array
              items:
                type: string
            bulkRowHooks:
              type: array
              items:
                type: string
            rowDeleteHooks:
              type: array
              items:
                type: string
            beforeFinishCallback:
              type: string
            columnHooks:
              type: array
              items:
                type: object
                properties:
                  fieldName:
                    type: string
                  callback:
                    type: string
                required:
                  - fieldName
                  - callback
                additionalProperties: false
            stepHooks:
              type: array
              items:
                type: object
                properties:
                  type:
                    type: string
                    enum:
                      - UPLOAD_STEP
                      - REVIEW_STEP
                      - REVIEW_STEP_POST_HOOKS
                  callback:
                    type: string
                required:
                  - type
                  - callback
                additionalProperties: false
          additionalProperties: false
      required:
        - name
        - fields
        - settings
  securitySchemes:
    api_key:
      type: apiKey
      name: X-Dromo-License-Key
      in: header
      description: >-
        This backend API key is different than your frontend license key. Please
        use the "Backend" license key from your [Dromo
        Dashboard](https://dashboard.dromo.io/).

````